﻿using Syncfusion.SfDataGrid.XForms;
using Syncfusion.SfDataGrid.XForms.Exporting;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace DataGridDemo
{
    public partial class MainPage : ContentPage
    {
        public MainPage()
        {
            InitializeComponent();
        }

        private void Export_Clicked(object sender, EventArgs e)
        {
            DataGridPdfExportingController pdfExport = new DataGridPdfExportingController();
            pdfExport.RowExporting += PdfExport_RowExporting;
            MemoryStream stream = new MemoryStream();
            var exportToPdf = pdfExport.ExportToPdf(this.sfGrid);
            exportToPdf.Save(stream);
            exportToPdf.Close(true);
            if (Device.OS == TargetPlatform.WinPhone || Device.OS == TargetPlatform.Windows)
                Xamarin.Forms.DependencyService.Get<ISaveWindows>().Save("DataGrid.pdf", "application/pdf", stream);
            else
                Xamarin.Forms.DependencyService.Get<ISave>().Save("DataGrid.pdf", "application/pdf", stream);
        }

        private void PdfExport_RowExporting(object sender, DataGridRowPdfExportingEventArgs e)
        {
            e.PdfGrid.Columns[2].Width = 200;
        }

    }

    public interface ISave
    {
        void Save(string filename, string contentType, MemoryStream stream);
    }

    public interface ISaveWindows
    {
        Task Save(string filename, string contentType, MemoryStream stream);
    }
}
